#include <unistd.h>
#include <stdio.h>
#include "myio.h"

#define cli() __asm__ __volatile__ ("cli": : :"memory")
#define sti() __asm__ __volatile__ ("sti": : :"memory")

#define DATA 0x378
#define STATUS 0x379

main() {
  unsigned char lastinput, input;
  unsigned char k, k_old, d;
  unsigned long timer;
  int flanke = 1;
  iopl(3);

  outb(0xff, DATA);
  sleep(1);
  fprintf(stderr, "Bitte jetzt Magnetkarte durch den Leser ziehen.\n");
  lastinput = 0;
  k_old = 1;
  timer = 0;

/*  fprintf(stderr, "%x\n", inb(STATUS)); */

  while((timer < 100000) || flanke) {
    input = inb(STATUS);
    d = (input & 0x80) >> 7;
    k = (input & 0x40) >> 6;
    if((k == 0) && (k_old == 1)) {
      putchar(d + '0');
/*      fprintf(stderr, "%x\n", input); */
      if(flanke) {
        cli();
        flanke = 0;
      }
      if(timer == 1) {
        fprintf(stderr, "Too fast! Try again!\n");
      }
      timer = 0;
    } else {
      timer++;
    }

    k_old=k;
  }
  sti();
/*  fprintf(stderr, "%x\n", inb(STATUS)); */
  outb(0x00, DATA);
  printf("\n");
}  
