#include <stdio.h>
#define KUHN

int p[15][10] = { { 0, 4, 2, 2, 2, 2, 1, 1, 1, 1 },
		  { 2, 2, 2, 2, 2, 2, 1, 1, 1, 1 },
		  { 2, 2, 2, 2, 2, 2, 1, 1, 1, 1 },
		  { 2, 2, 2, 2, 2, 2, 1, 1, 1, 1 },
		  { 2, 2, 2, 2, 2, 2, 1, 1, 1, 1 },
		  { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
		  { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
		  { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
		  { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
		  { 2, 2, 2, 2, 2, 2, 1, 1, 1, 1 },
		  { 0, 4, 2, 2, 2, 2, 1, 1, 1, 1 },
		  { 2, 2, 2, 2, 2, 2, 1, 1, 1, 1 },
		  { 2, 2, 2, 2, 2, 2, 1, 1, 1, 1 },
		  { 2, 2, 2, 2, 2, 2, 1, 1, 1, 1 },
		  { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 }};
	
int n=0;
	 
int po(int pin, int offset) {
  /* fprintf(stderr, "%i %i %i %i\n", pin, offset, (pin + 10 - offset)%10, p[4 + n][(pin + 10 - offset)%10]); */
#if defined(KUHN)
  return p[4 + n][(pin + 10 - offset)%10];
#elif defined(ADD)
  return p[4 + n][(offset + pin)%10];
#else
  return p[4 + n][(offset + 10 - pin)%10];
#endif
}

int main(int argc, char* argv[]) {
  int stelle ,stelle2, offset, i;
  int probdivisor;
  int probdivsum;
  int probsum[4];
  int prob[4][10];
  int stellen[4];
  double pinprob;

  n = atoi(argv[1]);

  for(stelle = 0; stelle < 4; stelle++) {
    probdivsum = 0;
    for(i=0; i<10; i++) {
      probdivisor = p[stelle + n][i];
      for(offset = 0; offset<argc - 2; offset++) {
	probdivisor *= po(i, argv[offset + 2][stelle] - '0');
      }
      prob[stelle][i] = probdivisor;
      probdivsum += probdivisor;
    }
    probsum[stelle] = probdivsum;
  }
  for(stelle = 0; stelle<4; stelle++) {
    for(i=0; i<10; i++) {
      printf("%f ", (float)(prob[stelle][i]) / (float)(probsum[stelle]));
    }
    printf("\n");
  }
  fflush(stdout);
#if 0
  for(stellen[0] = 0; stellen[0] < 10; stellen[0]++) {
    for(stellen[1] = 0; stellen[1] < 10; stellen[1]++) {
      for(stellen[2] = 0; stellen[2] < 10; stellen[2]++) {
	for(stellen[3] = 0; stellen[3] < 10; stellen[3]++) {
	  pinprob = 1.0;
	  for(stelle = 0; stelle< 4; stelle++) {
	    printf("%i", stellen[stelle]);
	    pinprob *= ((float)(prob[stelle][stellen[stelle]]) / (float)(probsum[stelle]));
	  }
	  printf(" %lf\n", pinprob);
	}
      }
    }
  }
#endif
}
